Package weka.filters.unsupervised.instance.subsetbyexpression

# Class Parser

java.lang.Object
java_cup.runtime.lr_parser
weka.filters.unsupervised.instance.subsetbyexpression.Parser

public class Parser extends java_cup.runtime.lr_parser
CUP v0.11a beta 20060608 generated parser.

Version:
  Wed Jun 26 14:32:21 NZST 2013

## Field Summary

### Fields inherited from class java_cup.runtime.lr_parser

`symbolFactory`

## Constructor Summary

Constructors
Constructor
Description
`Parser()`
Default constructor.
`Parser(java_cup.runtime.Scanner s)`
Constructor which sets the default scanner.
`Parser(java_cup.runtime.Scanner s, java_cup.runtime.SymbolFactory sf)`
Constructor which sets the default scanner.

## Method Summary

Modifier and Type
Method
Description
`short[][]`
`action_table()`
Access to parse-action table.
`java_cup.runtime.Symbol`
`do_action(int act_num, java_cup.runtime.lr_parser parser, Stack stack, int top)`
Invoke a user supplied parse action.
`int`
`EOF_sym()`
`EOF` Symbol index.
`int`
`error_sym()`
`error` Symbol index.
`static Instances`
`filter(String expression, Instances input)`
Filters the input dataset against the provided expression.
`Hashtable`
`getAttributeTypes()`
Returns the current attribute - attribute-type relation in use.
`Boolean`
`getResult()`
Returns the result of the evaluation.
`HashMap`
`getSymbols()`
Returns the current variable - value relation in use.
`static Object`
`getValue(Instance instance, int index)`
Returns either a String object for nominal attributes or a Double for numeric ones.
`static void`
`main(String[] args)`
Runs the parser from commandline.
`short[][]`
`production_table()`
Access to production table.
`short[][]`
`reduce_table()`
Access to `reduce_goto` table.
`void`
`setAttributeTypes(Hashtable value)`
Sets the attribute - attribute-type relation to use.
`void`
`setResult(Boolean value)`
Sets the result of the evaluation.
`void`
`setSymbols(HashMap value)`
Sets the variable - value relation to use.
`int`
`start_production()`
Indicates start production.
`int`
`start_state()`
Indicates start state.

### Methods inherited from class java_cup.runtime.lr_parser

`debug_message, debug_parse, debug_reduce, debug_shift, debug_stack, done_parsing, dump_stack, expected_token_ids, getScanner, getSymbolContainer, getSymbolFactory, parse, report_error, report_fatal_error, scan, setScanner, symbl_name_from_id, syntax_error, unrecovered_syntax_error, user_init`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Constructor Details

### Parser

public Parser()
Default constructor.

### Parser

public Parser(java_cup.runtime.Scanner s)
Constructor which sets the default scanner.

### Parser

public Parser(java_cup.runtime.Scanner s, java_cup.runtime.SymbolFactory sf)
Constructor which sets the default scanner.

## Method Details

### production_table

public short[][] production_table()
Access to production table.

Specified by:
  `production_table` in class `java_cup.runtime.lr_parser`

### action_table

public short[][] action_table()
Access to parse-action table.

Specified by:
  `action_table` in class `java_cup.runtime.lr_parser`

### reduce_table

public short[][] reduce_table()
Access to `reduce_goto` table.

Specified by:
  `reduce_table` in class `java_cup.runtime.lr_parser`

### do_action

public java_cup.runtime.Symbol do_action(int act_num, java_cup.runtime.lr_parser parser, Stack stack, int top) throws Exception
Invoke a user supplied parse action.

Specified by:
  `do_action` in class `java_cup.runtime.lr_parser`
Throws:
  `Exception`

### start_state

public int start_state()
Indicates start state.

Specified by:
  `start_state` in class `java_cup.runtime.lr_parser`

### start_production

public int start_production()
Indicates start production.

Specified by:
  `start_production` in class `java_cup.runtime.lr_parser`

### EOF_sym

public int EOF_sym()
`EOF` Symbol index.

Specified by:
  `EOF_sym` in class `java_cup.runtime.lr_parser`

### error_sym

public int error_sym()
`error` Symbol index.

Specified by:
  `error_sym` in class `java_cup.runtime.lr_parser`

### setSymbols

public void setSymbols(HashMap value)
Sets the variable - value relation to use.

Parameters:
  `value` - the variable-value relation

### getSymbols

public HashMap getSymbols()
Returns the current variable - value relation in use.

Returns:
  the variable-value relation

### setAttributeTypes

public void setAttributeTypes(Hashtable value)
Sets the attribute - attribute-type relation to use.

Parameters:
  `value` - the att - att-type relation

### getAttributeTypes

public Hashtable getAttributeTypes()
Returns the current attribute - attribute-type relation in use.

Returns:
  the att - att-type relation

### setResult

public void setResult(Boolean value)
Sets the result of the evaluation.

Parameters:
  `value` - the result

### getResult

public Boolean getResult()
Returns the result of the evaluation.

Returns:
  the result

### getValue

public static Object getValue(Instance instance, int index)
Returns either a String object for nominal attributes or a Double for numeric ones. For all other attribute types this method throws an Exception. It also returns a Double object in case of a missing value (for all attribute types!).

Parameters:
  `instance` - the instance to work on
  `index` - the index of the attribute to return
Returns:
  the converted value

### filter

public static Instances filter(String expression, Instances input) throws Exception
Filters the input dataset against the provided expression.

Parameters:
  `expression` - the expression used for filtering
  `input` - the input data
Returns:
  the filtered data
Throws:
  `Exception` - if parsing fails

### main

public static void main(String[] args) throws Exception
Runs the parser from commandline. Takes the following arguments:

1. expression
2. input file
3. class index (first|last|num), use 0 to ignore
4. output file

Parameters:
  `args` - the commandline arguments
Throws:
  `Exception` - if something goes wrong